//+------------------------------------------------------------------+
//|                                  (lsv).mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                 :   03.09.2006 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

// <  ..> 
//     ()    
//    : 
// )       . 
//        , 
//    ,   ,     
//     Home.    / 
// ,         
//    (     .  
//   4). 
//          
//    Tester/files.      
//      Experts/files. 
// )          
//   .       
//     Experts/files.   
//        .  
//    ,     
//       .    
// ,  ,    , 
//   ,      
// ,      
//   .     
//     ,   
//           
//  .     
//  .      
//    ,    
//  .      Experts/files 
//         -. 
//     .    
//       ( - 
//     ).  ,   
//        .
//       ,   
// . 

// <.  ReadHistory.>
//           
// ,       ,  
//  Tester/files   .   
//         
//   .       
//         
// .       
//      ,   
//       
// .      
// ReadHistory.     ReadHistory=0, 
//          , 
//    .  ReadHistory=1, 
//        
//   . E ReadHistory=1,     
// ,        
// ( ),        
//    c  ReadHistory=0. 

// < .>
// - Probab    ,   
//  .   Probab  ,   
//       .  
//       . 
//        
//   .  ,    
//     . 
//        
//  .      
//   Probab=1,        
// ;

// - forg     .  1 ( 
// )  1.1 ( ).  ,   
//      . , 
//     .  ,    , 
//   ,       
//    Buy,      
//    Sell.   forg=1, 
//      , 
//       .    
//    (Probab)    , 
//      .    , 
//       . , 
//   forg>1 ,    , 
//      ,   
//   .      
//       
//   forg .  ,  forg=1.05  
//      10-15  
//  ;

// - dstop =TakeProfit=StopLoss.      
//   ,   . 
// ,    ,   
//  .

// - delta   ,     
//  ,     
// .         
//  1-2 (    ),   
//          
// , delta=3-5. ,   , 
//   delta    ;
 
// - Nidelt      (    
// ).   ,     
//   .      
//  ,     Nidelt   
//  NN  .    idelt  
//    delta*idelt,  1<idelt<Nidelt.
//  ,       
//    .     
//     ,      
//      (   delta*idelt), 
//         , 
//    .

// - NN   .   ,   
//   .    ,   
//   ( ),      , 
//     ,    
//   .   ,  
//   ,   ,   
//      ,    
//  .      
// NN!  NN=10      ;

// - Lots -   ();

// - Nstop         
//    .

//---- input parameters 
extern double Lots = 0.1; 
extern int    ReadHistory = 1; //  (1)    (0) 
extern double Probab = 0.8;    //   
extern int    dstop = 25;      //      
extern int    Nstop = 1;       //        3 
extern int    delta = 1;       //     
extern int    Nidelt = 20;     //         30 
extern int    NN = 10;         //     12 
extern double forg = 1.05;     //    
extern bool   ReplaceStops = true; 
extern double lTrailingStop = 510; 
extern double sTrailingStop = 510; 
//----  
int MagicID;               //       
int mn, Ncomb, izm, ii, metka, file1, idelt, i, istop, Take0, Stop0, 
    TrailingStop, total, ticket; 
int buy_open, sell_open, buy_close, sell_close, nb, ns, iii, 
    ReWriteHistory; 
double time0, prob, prob0, OpenPriceBuy, OpenPriceSell, LastBuyOpen, LastSellOpen; 
string FileName;
int delt[30], sr[50,30], sd[5000,30,3], stop[3], nsd[5000,30,3]; 
double P[12,30], pt[30], cen[5000,30,3], rost[5000,30,3], spad[5000,30,3], LastSd[5000,30,3]; 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init() 
  { 
   MagicID = 796385000 + Period();
//   .      
   for(idelt = 1; idelt <= Nidelt; idelt++)
     { 
       delt[idelt] = delta*idelt; 
       for(i = 1; i <= NN - 1; i++)
           P[i,idelt] = Close[i-1]; 
     } 
   return(0);
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() 
  {
   return(0);
  } 
//+------------------------------------------------------------------+ 
//| expert start function                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int a;
//      
//  if(iii==0){Alert("-     ");iii=1;} 
//  if(IsTesting()==false)return(0); 
//************************************************ 
   buy_open = 0; sell_open = 0; buy_close = 0; sell_close = 0;     
//----
   if(ReadHistory == 0)
       ReWriteHistory = 1; 
//----
   if(Bars < 205 || AccountFreeMargin() < 10)
       return(0); 
//----
   for(idelt = 1; idelt <= Nidelt; idelt++)
     { 
       delt[idelt] = delta*idelt; 
       //     delta*idelt 
       if(MathAbs(Ask - P[1, idelt]) > (delt[idelt] - 0.5)*Point) 
         { 
           for(i = 1; i <= NN - 1; i++)
             { 
               P[NN+1-i, idelt] = P[NN-i, idelt];  
             } 
           P[1,idelt] = Ask; 
         } 
       //       
       if(MathAbs(P[1, idelt] - pt[idelt]) > 0.5*Point)
         { 
           //    
           for(i = 1; i <= NN - 1; i++)
             { 
               if(P[i,idelt] > P[i+1, idelt])
                 {
                   sr[i, idelt] = 1;
                 }
               else 
                 {
                   sr[i,idelt] = 0;
                 } 
             } 
           //    
           Ncomb = 0;  mn = 1;    
           //----
           for(i = 1; i <= NN - 1; i++)
             { 
               Ncomb = Ncomb + mn*sr[i, idelt]; 
               mn = 2*mn;
             } 
           //     ,       
           //      c        
           for(istop = 1; istop <= Nstop; istop++)
             { 
               if(sd[Ncomb, idelt, istop] == 0 && CurTime() - LastSd[Ncomb, idelt, istop] > 
                  2*Period()*60) 
                 {
                   sd[Ncomb, idelt, istop] = 1; 
                   cen[Ncomb, idelt, istop] = Ask; 
                   LastSd[Ncomb, idelt, istop] = CurTime();
                 } 
             } 
           //        
           for(istop = 1; istop <= Nstop; istop++)
             { 
               stop[istop] = dstop*istop; 
               //----
               for(i = 0; i <= mn - 1; i++)
                 { 
                   if(sd[i, idelt, istop] == 1)
                     { 
                       if(Ask - cen[i, idelt, istop] > stop[istop]*Point) 
                         {
                           rost[i, idelt, istop] = rost[i, idelt, istop] / forg + 1; 
                           spad[i, idelt, istop] = spad[i, idelt, istop] / forg; 
                           sd[i, idelt, istop] = 0; 
                           nsd[i, idelt, istop] = nsd[i, idelt, istop] + 1;
                         } 
                       //----
                       if(cen[i, idelt, istop] - Ask > stop[istop]*Point) 
                         {
                           spad[i, idelt, istop] = spad[i, idelt, istop] / forg + 1; 
                           rost[i, idelt, istop] = rost[i, idelt, istop] / forg; 
                           sd[i, idelt, istop] = 0; 
                           nsd[i, idelt, istop] = nsd[i, idelt, istop] + 1;
                         }  
                     } 
                 } 
             } 
           //      ,    
           //   
           for(istop = 1; istop <= Nstop; istop++)
             {
               stop[istop] = dstop*istop; 
               prob = rost[Ncomb, idelt, istop] / (rost[Ncomb, idelt, istop] + 
                      spad[Ncomb, idelt, istop] + 0.0001); 
               //----
               if(prob > Probab && nsd[Ncomb, idelt, istop] > 10 && CurTime() - 
                  LastBuyOpen > 2*Period()*60)  
                 {
                   Take0 = stop[istop]; 
                   Stop0 = stop[istop];  
                   buy_open = 1; 
                   //----
                   a = OrdersTotal();
                   //----
                   for(i=0; i<a; i++)
                       if(MyOrder(i))
                         {               //   
                           if(OrderType() == OP_SELL)
                             {          
                               FileName = "FDlast_sell" + Symbol() + Period();
                               file1 = FileOpen(FileName, FILE_CSV | FILE_READ); 
                               prob0 = FileReadNumber(file1); 
                               //----
                               if(prob > (prob0 + 0.05))
                                 sell_close = 1; 
                               FileClose(file1); 
                             }
                         }
                   FileName = "FDlast_buy" + Symbol() + Period(); 
                   file1 = FileOpen(FileName, FILE_CSV | FILE_WRITE); 
                   FileWrite(file1, prob); 
                   FileClose(file1);        
                 } 
               //    
               a = OrdersTotal();
               //----
               for(i=0; i<a; i++)
                   if(MyOrder(i))
                     {
                       if(OrderType() == OP_SELL)
                         {                  
                           if(prob > 0.6 && nsd[Ncomb, idelt, istop] > 10 &&
                             (OrderOpenPrice() - Ask) > (dstop / 2)*Point) 
                               sell_close = 1; 
                         }
                     }
               prob = spad[Ncomb, idelt, istop] / (rost[Ncomb, idelt, istop] + 
                      spad[Ncomb, idelt, istop] + 0.0001); 
               //----
               if(prob > Probab && nsd[Ncomb, idelt, istop] > 10 && CurTime() - 
                  LastSellOpen > 2*Period()*60)  
                 {
                   Take0 = stop[istop]; 
                   Stop0 = stop[istop]; 
                   sell_open = 1; 
                   //----
                   a = OrdersTotal();
                   //----
                   for(i=0; i<a; i++)
                       if(MyOrder(i))
                         {
                           if(OrderType() == OP_BUY)
                             {                            
                               FileName = "FDlast_buy" + Symbol() + Period(); 
                               file1 = FileOpen(FileName, FILE_CSV | FILE_READ); 
                               prob0 = FileReadNumber(file1); 
                               //----
                               if(prob > (prob0 + 0.05))
                                   buy_close = 1; 
                               FileClose(file1); 
                             }
                         }
                   FileName = "FDlast_sell" + Symbol() + Period();
                   file1 = FileOpen(FileName, FILE_CSV | FILE_WRITE); 
                   FileWrite(file1, prob); 
                   FileClose(file1);              
                 } 
               //   
               a = OrdersTotal();
               //----
               for(i=0; i<a; i++)
                   if(MyOrder(i))
                     {
                       if(OrderType() == OP_BUY)
                         {                                    
                           if(prob > 0.6 && nsd[Ncomb, idelt, istop] > 10 && 
                             (Bid - OrderOpenPrice()) > (dstop / 2)*Point)
                               buy_close = 1; 
                         }
                     }
             }  
           izm = izm + 1;  
         }  
       pt[idelt]=P[1,idelt]; 
     } 
//    
   if(ii == 0)
     { 
       FileName = "FD_" + Symbol();
       ii = 1; 
       file1 = FileOpen(FileName, FILE_CSV | FILE_READ); 
       metka = FileReadNumber(file1);
       time0 = FileReadNumber(file1); 
       //----
       if(metka == 1 && ReadHistory == 1 && ReWriteHistory != 1)
         { 
           /* for(idelt = 1; idelt <= Nidelt; idelt++)
                {
                  for(i = 1; i <= NN; i++)
                    { 
                      P[i,idelt] = FileReadNumber(file1);
                    }
                } 
           */     
           for(istop = 1; istop <= Nstop; istop++)
             { 
               for(idelt = 1; idelt <= Nidelt; idelt++)
                 { 
                   for(i= 0; i <= mn - 1; i++)
                     { 
                       rost[i,idelt,istop] = FileReadNumber(file1); 
                       spad[i,idelt,istop] = FileReadNumber(file1); 
                       nsd[i,idelt,istop] = FileReadNumber(file1); 
                     }
                 }
             }  
         }  
       FileClose(file1); 
     } 
//     100   
//       
   if(izm > 10 && (CurTime() >= time0 || ReWriteHistory == 1))
     { 
       izm = 0; 
       FileName = "FD_" + Symbol();
       file1=FileOpen(FileName, FILE_CSV | FILE_WRITE); 
       FileWrite(file1, "1");
       FileWrite(file1, CurTime()); 
       /* for(idelt = 1; idelt <= Nidelt; idelt++)
            {
              for(i=1;i<=NN;i++)
                { 
                  FileWrite(file1, P[i,idelt]);
                }    
            }
       */       
       for(istop = 1; istop <= Nstop; istop++)
         { 
           for(idelt = 1; idelt <= Nidelt; idelt++)
             { 
               for(i = 0; i <= mn - 1; i++)
                 {  
                   FileWrite(file1, rost[i,idelt,istop]); 
                   FileWrite(file1, spad[i,idelt,istop]); 
                   FileWrite(file1, nsd[i,idelt,istop]); 
                 }
             }
         } 
       FileClose(file1);  
     } 
//   
   a = OrdersTotal();
   total = 0;  //      ( 1-   )
//----
   for(i = 0; i < a; i++)
     if(MyOrder(i))
         total ++;
//       
   if(total == 0) 
     {    
       if(buy_open == 1 && MathAbs(OpenPriceBuy - Ask) > 10*Point)
         { 
           OrderNew(OP_BUY);
           return(0);
         } 
       //----
       if(sell_open == 1 && MathAbs(OpenPriceSell - Bid) > 10*Point)
         { 
           OrderNew(OP_SELL);
           return(0);
         } 
     }  
//----
   if(total == 1)
     { 
       a = OrdersTotal();
       //----
       for(i = 0; i < a; i++)
           if(MyOrder(i))
             {
               if(OrderType() == OP_SELL)
                 {    
                   if(buy_open == 1 && MathAbs(OpenPriceSell - Bid) > 10*Point)
                     { 
                       OrderNew(OP_BUY);
                       return(0);
                     }
                 } 
               //----
               if(OrderType() == OP_BUY)
                 { 
                   if(sell_open == 1 && MathAbs(OpenPriceBuy - Ask) > 10*Point)
                     { 
                       OrderNew(OP_SELL);
                       return(0);
                     }
                 }  
             }
     } 
//           
   a = OrdersTotal();
//----
   for(i = 0; i < a; i++)
       if(MyOrder(i))
         {
           if(OrderType() == OP_BUY && buy_open == 1 && Bid - OrderStopLoss() > Stop0*Point)
             { 
               OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Stop0*Point, 
                           Bid + Take0*Point, 0, Orange);  
               return(0);
             } 
           //----
           if(OrderType() == OP_SELL && sell_open == 1 && OrderStopLoss() - Ask > Stop0*Point)
             { 
               OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Stop0*Point, 
                           Ask - Take0*Point, 0, Red); 
               return(0);                  
             } 
         }
//   ,      
   a = OrdersTotal();
//----
   for(i = 0; i < a; i++)
       if(MyOrder(i))
         {
           if(OrderType() == OP_BUY)
             {
               buy_open = 0;   
               LastBuyOpen = CurTime(); 
               OpenPriceBuy = OrderOpenPrice();
             } 
           //----
           if(OrderType() == OP_SELL)
             {
               sell_open = 0; 
               LastSellOpen = CurTime(); 
               OpenPriceSell = OrderOpenPrice();
             } 
         }
//       
   a = OrdersTotal();
//----
   for(i = 0; i < a; i++)
       if(MyOrder(i))
         {
           if(buy_close == 1 && OrderType() == OP_BUY)
             { 
               OrderClose(OrderTicket(), OrderLots(), Bid, 3, Orange);
               return(0);  
             } 
           //----
           if(sell_close == 1 && OrderType() == OP_SELL)
             { 
               OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet);   
               return(0);  
             }  
         }
//   ,      
   nb = 0;
   ns = 0; 
   a = OrdersTotal();
   for(i = 0; i < a; i++)
       if(MyOrder(i))
         {
           if(OrderType() == OP_BUY)
               nb = 1; 
           if(OrderType() == OP_SELL)
               ns = 1;  
         }
//----
   if (nb == 0)
       buy_close = 0;  
//----
   if (ns == 0)
       sell_close = 0;    
//  
   a = OrdersTotal();
   for(i = 0; i < a; i++)
       if(MyOrder(i))
         {
           if(OrderType() == OP_BUY && TrailingStop > 10)
             {  
               if(OrderStopLoss() < Bid - Point*TrailingStop)      
                   OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point*TrailingStop, 
                               Bid + Point*TrailingStop, 0, Orange);      
             } 
           if(OrderType() == OP_SELL && TrailingStop > 10)
             { 
               if(OrderStopLoss() > Ask + Point*TrailingStop) 
                   OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point*TrailingStop, 
                               Ask - Point*TrailingStop, 0, Red);              
             } 
         }
   return(0); 
  } 
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
void OrderNew(int cmd)
  {
    if(cmd == OP_BUY)
      { 
        ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask - Stop0*Point, 
                           Ask + Take0*Point, "AT", MagicID, 0, Blue);
        //----
        if(ticket < 0)
            Print(" OrderSend() Error: ", GetLastError());
        else
            Print("Trying to open BUY price: ", Ask, " Stop ", Ask - Stop0*Point, 
                  " TP ", Point, Ask + (Take0*Point)); 
      } 
    else
      { 
        ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid + Stop0*Point, 
                           Bid - Take0*Point, "AT", MagicID, 0, Red);    
        //----
        if(ticket < 0)
            Print(" OrderSend() Error: ", GetLastError());
        else
            Print("Trying to open SELL price: ", Bid, " Stop ", Bid + Stop0*Point, 
                  " TP ", Bid - Take0*Point);  
      } 
  }
//+------------------------------------------------------------------+
//  TRUE       
//+------------------------------------------------------------------+
bool MyOrder(int a)
  {
    return(OrderSelect(a, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() &&
           OrderMagicNumber() == MagicID);
  }
//+------------------------------------------------------------------+